


#include "LCD.h"
#include "FonctionsI2C.h"
#include "Platine.h"
#include "Utilitaires.h"
#include "Parametres.h"



extern unsigned char g_EtatDuRetroeclairage;



/* Envoyer une commande  l'afficheur alphanumrique, grce au module  I2C 1  du STM32F100RB 

Paramtre d'entre :

Commande - Commande  envoyer.

Valeur de retour :

Aucune.

*/
void EnvoiCommande(unsigned char Commande)
{
	unsigned char CommandePoidsFaible;
	unsigned char CommandePoidsFort;

	CommandePoidsFaible = (0x0F & Commande);
	CommandePoidsFort = ((0xF0 & Commande) >> 4);

	/* Dbut de l'envoi de la premire partie de l'octet  Commande . */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | CommandePoidsFort));	/* DB<4:7> = CommandePoidsFort, RS = 0, R/W = 0, E = 0 */

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_E | CommandePoidsFort));	/* DB<4:7> = CommandePoidsFort, RS = 0, R/W = 0, E = 1 */

	Delai(3000);

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | CommandePoidsFort));	/* DB<4:7> = CommandePoidsFort, RS = 0, R/W = 0, E = 0 */
	/* Validation de l'envoi de la premire partie de l'octet  Commande  au moment du front descendant de l'entre  E . */
	/* Fin de l'envoi de la premire partie de l'octet  Commande . */

	/* Dbut de l'envoi de la deuxime partie de l'octet  Commande . */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | CommandePoidsFaible));	/* DB<4:7> = CommandePoidsFaible, RS = 0, R/W = 0, E = 0 */

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_E | CommandePoidsFaible));	/* DB<4:7> = CommandePoidsFaible, RS = 0, R/W = 0, E = 1 */

	Delai(3000);

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | CommandePoidsFaible));	/* DB<4:7> = CommandePoidsFaible, RS = 0, R/W = 0, E = 0 */
	/* Validation de l'envoi de la deuxime partie de l'octet  Commande  au moment du front descendant de l'entre  E . */
	/* Fin de l'envoi de la deuxime partie de l'octet  Commande . */
}

/* Envoyer une donne  l'afficheur alphanumrique, grce au module  I2C 1  du STM32F100RB 

Paramtre d'entre :

donnee - Donne  envoyer.

Valeur de retour :

Aucune.

*/
void EnvoiDonnee(unsigned char Donnee)
{
	unsigned char DonneePoidsFaible;
	unsigned char DonneePoidsFort;

	DonneePoidsFaible = (0x0F & Donnee);
	DonneePoidsFort = ((0xF0 & Donnee) >> 4);

	/* Dbut de l'envoi de la premire partie de l'octet  Donnee . */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RS | DonneePoidsFort));	/* DB<4:7> = DonneePoidsFort, RS = 1, R/W = 0, E = 0 */

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RS | LCD_E | DonneePoidsFort));	/* DB<4:7> = DonneePoidsFort, RS = 1, R/W = 0, E = 1 */

	Delai(30);

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RS | DonneePoidsFort));	/* DB<4:7> = DonneePoidsFort, RS = 0, R/W = 0, E = 0 */
	/* Validation de l'envoi de la premire partie de l'octet  Donnee  au moment du front descendant de l'entre  E . */
	/* Fin de l'envoi de la premire partie de l'octet  Donnee . */

	/* Dbut de l'envoi de la deuxime partie de l'octet  Donnee . */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RS | DonneePoidsFaible));	/* DB<4:7> = DonneePoidsFaible, RS = 1, R/W = 0, E = 0 */

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RS | LCD_E | DonneePoidsFaible));	/* DB<4:7> = DonneePoidsFaible, RS = 1, R/W = 0, E = 1 */

	Delai(30);

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | DonneePoidsFaible));	/* DB<4:7> = DonneePoidsFaible, RS = 0, R/W = 0, E = 0 */
	/* Validation de l'envoi de la deuxime partie de l'octet  Donnee  au moment du front descendant de l'entre  E . */
	/* Fin de l'envoi de la deuxime partie de l'octet  Donnee . */
}

/* Obtenir l'adresse du curseur, sur l'afficheur alphanumrique, grce au module  I2C 1  du STM32F100RB 

Paramtre d'entre :

Aucun.

Valeur de retour :

Adresse du curseur, sur l'afficheur alphanumrique.

*/
unsigned char ObtenirAdresseActuelle(void)
{
	unsigned char ValeurAdresseObtenue = 0x00;

	/* Dbut de la rcupration de la premire partie de l'octet  ValeurAdresseObtenue  */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RW | 0x0F));	/* RS = 0, R/W = 1, E = 0 */
	/* Les broches  DB4  ,  DB5  ,  DB6  , et  DB7  sont mises
	dans un tat logique haut faible,
	afin de permettre  l'afficheur LCD alphanumrique d'imposer les tats logiques qu'il dsire sur ces broches. */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RW | LCD_E | 0x0F));	/* RS = 0, R/W = 1, E = 1 */
	Delai(30);
	/* Validation de la rception de la premire partie de l'octet  ValeurAdresseObtenu  aprs un retard conscutif au front montant de l'entre  E  */
	/* Rcupration de la premire partie de l'octet  ValeurAdresseObtenue , sans la valeur du  BUSY FLAG  */
	ValeurAdresseObtenue = ((0x07 & Lire(ADRESSE_EXPANSEUR | 0x01)) << 4);
	/* Fin de la rcupration de la premire partie de l'octet  ValeurAdresseObtenue  */

	/* Dbut de la rcupration de la deuxime partie de l'octet  ValeurAdresseObtenue  */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RW | 0x0F));	/* RS = 0, R/W = 1, E = 0. */
	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RW | LCD_E | 0x0F));	/* RS = 0, R/W = 1, E = 1 */
	Delai(30);
	/* Validation de la rception de la deuxime partie de l'octet  ValeurAdresseObtenu  aprs un retard conscutif au front montant de l'entre  E  */
	/* Rcupration de la deuxime partie de l'octet  ValeurAdresseObtenue  */
	ValeurAdresseObtenue |= (0x0F & Lire(ADRESSE_EXPANSEUR | 0x01));

	Ecrire(ADRESSE_EXPANSEUR, (g_EtatDuRetroeclairage | LCD_RW | 0x0F));	/* RS = 0, R/W = 1, E = 0 */
	Ecrire(ADRESSE_EXPANSEUR, g_EtatDuRetroeclairage);	/* RS = 0, R/W = 0, E = 0 */
	/* Fin de la rcupration de la deuxime partie de l'octet  ValeurAdresseObtenue  */

	return ValeurAdresseObtenue;
}

/* Envoyer huit caractres spciaux, dfinis par l'utilisateur,  l'afficheur alphanumrique.

Paramtre d'entre :

CaracteresSpeciaux - Tableau contenant la dfinition des huit caractres spciaux, dfinis par l'utilisateur.

Valeur de retour :

Aucune.

*/
void ChargeCaracteres(const char * CaracteresSpeciaux)
{
    unsigned char k;

	/* Placement du curseur dans la  CG RAM  de l'afficheur LCD alphanumrique */
	EnvoiCommande(0x40);

	for(k = 0; k < 64; k++)
	{
		EnvoiDonnee(CaracteresSpeciaux[k]);
	}

	/* Placement du curseur  la premire position o
	l'on peut afficher des caractres, sur l'afficheur LCD alphanumrique */
    PlacerCurseur(0x00);
}

/* Initialiser l'afficheur alphanumrique

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void InitialisationAfficheur(void)
{
	unsigned char k;
	unsigned char CommandesPourInitialisation[5] = {0x28, 0x01, 0x02, 0x06, 0x0C};

	/* 0x28 - SET FUNCTION - DL = 1 : 4 bits interface,
						   - N = 1 : 2 line display,
						   - F = 0 : 5 x 7 dots.
	
	   0x01 - DISPLAY CLEAR.
	
	   0x02 - RETURN HOME - Cursor move to first digit.
	
	   0x06 - ENTRY MODE SET - I / D = 1 : Increase,
							 - S / H = 0 : Display is no shifted.
	
	   0x0C - DISPLAY ON / OFF - D = 1 : Display on,
							   - C = 0 : Cursor off,
							   - B = 0 : Blinking off. */


	for(k = 0; k < 5; k++)
	{
		EnvoiCommande(CommandesPourInitialisation[k]);
	}
}

/* Mettre en veille l'afficheur alphanumrique

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void MiseVeilleAfficheur(void)
{
	unsigned char k;
	unsigned char CommandesPourVeille[3] = {0x01, 0x02, 0x08};

	/* 0x01 - DISPLAY CLEAR.
	
	   0x02 - RETURN HOME - Cursor move to first digit.
	
	   0x08 - DISPLAY ON / OFF - D = 0 : Display on,
							   - C = 0 : Cursor off,
							   - B = 0 : Blinking off. */

	for(k = 0; k < 3; k++)
	{
		EnvoiCommande(CommandesPourVeille[k]);
	}
}



/* Placer le curseur de l'afficheur alphanumrique  un endroit spcifi

Paramtre d'entre :

adresse_du_curseur - Adresse, sur l'afficheur alphanumrique, o placer le curseur.

Valeur de retour :

Aucune.

*/
void PlacerCurseur(unsigned char AdresseDuCurseur)
{
	EnvoiCommande(0x80 | AdresseDuCurseur);
}

/* Afficher un caractre, sur l'afficheur alphanumrique

Paramtre d'entre :

Caractere - Code ASCII du caractre  afficher.

Valeur de retour :

Aucune.

*/
void AfficheCaractere(unsigned char Caractere)
{
	EnvoiDonnee(Caractere);

	if(ObtenirAdresseActuelle() == FIN_PREMIER_ESPACE_AFFICHABLE)	/* Si l'on s'apprte  sortir du premier espace affichable */
	{
		PlacerCurseur(DEBUT_DEUXIEME_ESPACE_AFFICHABLE);	/* On place le curseur dans le deuxime espace affichable. */
	}
}



/* Afficher un texte, sur l'afficheur alphanumrique

Paramtre d'entre :

* Texte - Pointeur sur une chane de caractres, contenant les codes ASCII des caractres  afficher.

Valeur de retour :

Aucune.

*/
void AfficheTexte(const char * Texte)
{
	int k = 0;

	while (Texte[k] != '\0')
	{
		AfficheCaractere(Texte[k]);
		k++;
	}
}

/* Convertir un nombre dans une base, et afficher le rsultat de cette conversion, sur l'afficheur alphanumrique 

Paramtres d'entre :

Valeur - Nombre  afficher.
Base - Base de comptage du nombre  afficher, comprise entre 2 et 16.

Valeur de retour :

Aucune.

*/
void ConvertirEtAfficher(int Valeur, unsigned char Base)
{
	unsigned char Symboles[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

	int k = 0;
	static unsigned char Tampon[8];

	do
	{
		Tampon[k] = Symboles[Valeur % Base];
		Valeur = Valeur / Base;
		k++;
	}
	while(Valeur > 0);

	if((Base == 16) && (k == 1))
	{
		AfficheCaractere('0');
	}
	do
	{
		k--;
		AfficheCaractere(Tampon[k]);		
	}

	while(k > 0);
}


