


#include <stm32f10x_lib.h>

#include "FonctionsI2C.h"
#include "LCD.h"
#include "Caracteres.h"
#include "Platine.h"
#include "Utilitaires.h"
#include "Parametres.h"



extern unsigned char g_EtatDuRetroeclairage;



extern const char g_Speciaux_Generiques[64];
extern const char g_Speciaux_Accentues[64];
extern const char g_Speciaux_Progression[64];



void ConfigurationDesBroches(void);



void ConfigurationDesBroches(void)
{
	/* Activation de l'horloge du port B */
	RCC->APB2ENR |= (1 << 3);

    /* Configuration des broches  SDA  et  SCL  du module  I2C1 
	SDA : PB7,
	SCL : PB6. */
	GPIOB->CRL = ((GPIOB->CRL & 0x00FFFFFF) | (0xFF000000));
}

/* Fonction principale 

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
int main(void)
{
	unsigned char k;

	ConfigurationDesBroches();

	InitialisationI2C1();
			
	ChangerEtatRetroeclairage(1);
	
	InitialisationAfficheur();
	
	ChargeCaracteres(g_Speciaux_Generiques);	/* Chargement des huit caractres spciaux,
									dfinis dans le tableau  g_Speciaux  , points par points,
									dans la  CG RAM  de l'afficheur LCD alphanumrique. */
	
	EnvoiCommande(0x01);	/* Effacement de l'afficheur LCD. */
	Delai(1000);
	PlacerCurseur(0x00);	/* Placement du curseur  la premire position
							o l'on peut afficher des caractres, sur l'afficheur LCD alphanumrique. */	

	AfficheCaractere(0x04);	/* Affichage du caractre spcial d'adresse  0x02  - Symbole  Flche vers la gauche . */

	AfficheTexte(" FRAISES\0");	

	PlacerCurseur(0x40);

	AfficheTexte("MURES  \0");

	AfficheCaractere(0x05);	/* Affichage du caractre spcial d'adresse  0x03  - Symbole  Flche vers la droite . */

	Delai(3000);

	ChargeCaracteres(g_Speciaux_Progression);

	EnvoiCommande(0x01);	/* Effacement de l'afficheur LCD. */
	Delai(1000);
	PlacerCurseur(0x00);	/* Placement du curseur  la premire position
							o l'on peut afficher des caractres, sur l'afficheur LCD alphanumrique. */

	AfficheTexte("Progression :\0");

	for(k = 0; k < 16; k++)
	{
		PlacerCurseur(0x40 + k);
		AfficheCaractere(' ');
		Delai(1000);
		PlacerCurseur(0x40 + k);
		AfficheCaractere(0x00);	/* Affichage du caractre spcial d'adresse  0x00 . */
		Delai(1000);
		PlacerCurseur(0x40 + k);
		AfficheCaractere(0x01);	/* Affichage du caractre spcial d'adresse  0x01 . */
		Delai(1000);
		PlacerCurseur(0x40 + k);
		AfficheCaractere(0x02);	/* Affichage du caractre spcial d'adresse  0x02 . */
		Delai(1000);
		PlacerCurseur(0x40 + k);
		AfficheCaractere(0xFF);
		Delai(1000);
	}

	while(1);
}



/* Fonction qui permet l'initialisation du microcontrleur STM32F100RB

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void SystemInit (void)
{

}
